## tandemng-0.3.15.tar.gz

=== CMakeLists.txt ===
# CMake script to build tandemng (X!Tandem fork)
# Author: Olivier Langella
# Created: 27/06/2023
# Use git to check for contributions by other authors.

# Global parameters
CMAKE_MINIMUM_REQUIRED(VERSION 3.0)
PROJECT(tandemng CXX)

set(tandemng_VERSION_MAJOR "0")
set(tandemng_VERSION_MINOR "3")
set(tandemng_VERSION_PATCH "15")
set(tandemng_VERSION "${tandemng_VERSION_MAJOR}.${tandemng_VERSION_MINOR}.${tandemng_VERSION_PATCH}")
set(VERSION 0.3.15)


# Add folder where are supportive functions
set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
set(CMAKE_TOOLCHAINS_PATH ${CMAKE_UTILS_PATH}/toolchains)
set(CMAKE_MODULE_PATH ${CMAKE_UTILS_PATH}/modules)

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN64 if SYSTEM_UNAME_S is "^.*MING64.*"
include(${CMAKE_UTILS_PATH}/systemUname.cmake)

# Include the various colors we want to use in the output
include(${CMAKE_UTILS_PATH}/outputColors.cmake)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

message("\n${BoldRed}Configuring build for project ${CMAKE_PROJECT_NAME}${ColourReset}\n")

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)


# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "${BoldGreen}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#############################################################
# We do not want warnings for ucodenknown pragmas:
message(STATUS "Setting definition -Wno-unknown-pragmas.${ColourReset}")
add_definitions(-Wno-unknown-pragmas)
# Enable warnings and possibly treat them as errors
message(STATUS "${BoldGreen}Setting definition -Wall.${ColourReset}")
add_definitions(-Wall)
message(STATUS "${BoldGreen}Setting definition -Wextra.${ColourReset}")
add_definitions(-Wextra)

if(WARN_AS_ERROR)
  message(STATUS "${BoldYellow}Setting definition -Werror.${ColourReset}")
  add_definitions(-Werror)
endif()

message(STATUS "${BoldRed}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")


#############################################################
#############################################################
# Platform-specific CMake configuration
if(MXE)
  # Run the following cmake command line:
  # x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../development
  #include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)
  
  include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain-$ENV{USER}.cmake)

  # Set the name to the systemUname variable because in this situation that name
  # is not found, it it passed as a flag in the command line.
  set(systemUname "mxe")

elseif(UNIX AND NOT APPLE)
  # Run the following cmake command line:
  # cmake -DBUILD_USER_MANUAL=1 -DCMAKE_BUILD_TYPE=Debug
  # If the libraries to be used are local and not system-wide add
  # -DLOCAL_DEV=1

  # On UNIX, the libpappsomspp and libpappsomspp-widget libs
  # need to be installed and they ship the PappsoMSppConfig.cmake
  # config file.

  # However, when developing both libs and this program, we need to be able to
  # load the libs from their dev/build directory without relying on the system
  # libs.
  if(LOCAL_DEV)

    # The development should use the locally built libs.
    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain-local.cmake)
  else()

    # Use the system-wide libraries.
    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)

  endif()

  message(STATUS "Include dir for PappsoMSpp is at: ${PappsoMSpp_INCLUDE_DIRS}")
  message(STATUS "PappsoMSpp and PappsoMSppWidget were found at:
  \t ${PappsoMSpp_LIBRARIES} and ${PappsoMSppWidget_LIBRARIES}")

elseif(WIN64)
  # Run the following cmake command line:
  # cmake -DBUILD_USER_MANUAL=0 -DCMAKE_BUILD_TYPE=Release ../development

  include(${CMAKE_TOOLCHAINS_PATH}/win10-mingw64-toolchain.cmake)

elseif(APPLE)
  # Run the following cmake command line:
  # cmake -DBUILD_USER_MANUAL=0 -DCMAKE_BUILD_TYPE=Release ../development

  include(${CMAKE_TOOLCHAINS_PATH}/apple-macport-toolchain.cmake)

endif()

message("")
message(STATUS "${BoldGreen}Starting configuration of ${CMAKE_PROJECT_NAME}${ColourReset}")
message("")
message(STATUS "${BoldYellow}The build toolchain is: ${SystemUname}${ColourReset}")
message("")



#############################################################
#############################################################
# Essential software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

# Gee, do not set that to default!
# set(MAKE_TEST 1)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel."
    FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
  message(STATUS "Compiling in release mode.")
  add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
  message(STATUS "Compiling in debug mode with BUILD_TESTING: ${BUILD_TESTING}.")
  message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
  add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
  message(STATUS "Compiling in release with debug info mode.")
endif( CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo" )

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")


set(SOFTWARE_NAME "tandemng")

set(BUILD_SYSTEM_NAME "${CMAKE_SYSTEM_NAME}")

# Set the CMAKE_PREFIX_PATH for the find_library fonction when using non
# standard install location
if(CMAKE_INSTALL_PREFIX)
  set(CMAKE_PREFIX_PATH "${CMAKE_INSTALL_PREFIX}" ${CMAKE_PREFIX_PATH})
endif(CMAKE_INSTALL_PREFIX)

# Subdirectories
add_subdirectory(src)

add_subdirectory(src/2015)

add_subdirectory(src/2015p)

if(UNIX)


  # Doxygen
  find_package(Doxygen)
  if(DOXYGEN_FOUND)
    add_custom_target(apidoc cp Doxyfile ${CMAKE_BINARY_DIR}/Doxyfile-build
      COMMAND echo "OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}" >> ${CMAKE_BINARY_DIR}/Doxyfile-build
      COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile-build
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
    add_custom_target(apidoc-stable cp Doxyfile ${CMAKE_BINARY_DIR}/Doxyfile-stable
      COMMAND echo "OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}" >> ${CMAKE_BINARY_DIR}/Doxyfile-stable
      COMMAND echo "HTML_HEADER=header.html" >> ${CMAKE_BINARY_DIR}/Doxyfile-stable
      COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile-stable
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
  endif(DOXYGEN_FOUND)
endif(UNIX)
# Packager
set(CPACK_PACKAGE_NAME "tandemng")
set(CPACK_PACKAGE_VENDOR "PAPPSO Development Team")
set(CPACK_PACKAGE_VERSION "${tandemng_VERSION}")
set(CPACK_PACKAGE_VERSION_MAJOR "${tandemng_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${tandemng_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${tandemng_VERSION_PATCH}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "well known X!Tandem (thegpm.org) modified version from the latest ALANINE (2017.02.01)")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/INSTALL")
set(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/LICENSE")
set(CPACK_RESOURCE_FILE_INSTALL "${CMAKE_SOURCE_DIR}/README")
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_IGNORE_FILES
  "CMakeFiles"
  "Makefile"
  "_CPack_Packages"
  "CMakeCache.txt"
  ".*\\\\.git"
  ".*\\\\.gz"
  ".*\\\\.deb"
  ".*\\\\.rpm"
  ".*\\\\.dmg"
  ".*\\\\.xpip"
  ".*\\\\..*\\\\.swp"
  "src/\\\\..*"
  "src/libbpp*"
  "debian/tmp"
  "debian/libbpp.*/"
  "debian/libbpp.*\\\\.so.*"
  "debian/libbpp.*\\\\.a"
  "debian/libbpp.*\\\\.substvars"
  "debian/libbpp.*\\\\.debhelper"
  "debian/debhelper\\\\.log"
  ".kdev4/"
  "build/"
  "cbuild/"
  "wbuild/"
  "tests/tandem_input/"
  "tests/output/"
  "Core.tag"
  "Testing"
  "build-stamp"
  "install_manifest.txt"
  "DartConfiguration.tcl"
  ${CPACK_SOURCE_IGNORE_FILES}
  )



#dch -Djessie "message"
#cmake ..
#make deb
# scp tandemng* proteus.ideev.universite-paris-saclay.fr:/var/www/apt/incoming
# reprepro -Vb /var/www/apt processincoming default
#
#  debuild -S -sa
# dput -f olivier-langella *changes

if(MACOS)
  SET(CPACK_GENERATOR "Bundle")
endif()

set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
set(CPACK_DEBSOURCE_PACKAGE_FILE_NAME "lib${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}.orig")
iNCLUDE(CPack)

#This adds the 'dist' target
add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
# 'clean' is not (yet) a first class target. However, we need to clean the directories before building the sources:
if("${CMAKE_GENERATOR}" MATCHES "Make")
  add_custom_target(make_clean
    COMMAND ${CMAKE_MAKE_PROGRAM} clean
    WORKING_DIRECTORY ${CMAKE_CURRENT_DIR}
    )
  Add_dependencies(dist make_clean)
endif()

if(UNIX)
  #This creates deb packages:

  add_custom_target(targz
    cpack -G TGZ --config CPackSourceConfig.cmake && tar xvfz ${CPACK_PACKAGE_NAME}-${tandemng_VERSION}.tar.gz && ln -s ${CPACK_PACKAGE_NAME}-${tandemng_VERSION}.tar.gz ${CPACK_PACKAGE_NAME}_${tandemng_VERSION}.orig.tar.gz
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Creating .tar.gz" VERBATIM
    )


  add_custom_target(deb
    cd ${CPACK_PACKAGE_NAME}-${tandemng_VERSION} && dpkg-buildpackage -B
    DEPENDS targz
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Creating Debian package" VERBATIM
    )

  add_custom_target(deball
    cd ${CPACK_PACKAGE_NAME}-${tandemng_VERSION} && dpkg-buildpackage
    DEPENDS targz
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Creating Debian package" VERBATIM
    )
    
  add_custom_target(debsrc
    cd ${CPACK_PACKAGE_NAME}-${tandemng_VERSION} && debuild -S -sa
    DEPENDS targz
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Creating Debian package" VERBATIM
    )

  file(GLOB changesdebs "${CMAKE_BINARY_DIR}/${CPACK_PACKAGE_NAME}_*.dsc")

  foreach(libfile ${changesdebs})
    SET(changesdeb "${libfile}")
  endforeach(libfile)

  message ("changes debian file : ${changesdeb}")
  #lintian -IEi --pedantic tandem-mass_2013.06.15-1_amd64.changes
  add_custom_target(lintian
    lintian -IEi --pedantic ${changesdeb}
    DEPENDS deb
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "lintian check" VERBATIM
    )

endif(UNIX)

set(ctest_update_type GIT)
set(update_command "GIT")
set(UPDATE_OPTIONS "")



if(NOT APPLE)

  # We want to install the binary arch-dependent target in
  # specific situations. To have proper control, we define the arch
  # component.
  install(TARGETS ${TARGET}
    RUNTIME
    COMPONENT arch
    DESTINATION ${BIN_DIR})

endif()


configure_file (${CMAKE_SOURCE_DIR}/win64/tandemng.iss.cmake ${CMAKE_SOURCE_DIR}/win64/tandemng.iss)

=== src/2015/CMakeLists.txt ===
# CMake script to build tandemng (X!Tandem fork)
# Author: Olivier Langella
# Created: 24/02/2024


#configure_file(${CMAKE_SOURCE_DIR}/src/config.h.cmake ${CMAKE_SOURCE_DIR}/src/config.h)

# File list

file(GLOB CPP_FILES ${CMAKE_SOURCE_DIR}/src/msequence.cpp ${CMAKE_SOURCE_DIR}/src/masscalc.cpp ${CMAKE_SOURCE_DIR}/src/xmlparameter.cpp ${CMAKE_SOURCE_DIR}/src/msequtilities.cpp ${CMAKE_SOURCE_DIR}/src/mreport.cpp ${CMAKE_SOURCE_DIR}/src/lib/*.cpp ${CMAKE_SOURCE_DIR}/src/mzid_report.cpp ${CMAKE_SOURCE_DIR}/src/2015/*.cpp)

#message("i2MassChroQ_SRCS:  ${i2MassChroQ_SRCS}")


if(UNIX AND NOT APPLE)

  add_executable(tandemng2015 ${CPP_FILES})

elseif(APPLE)

elseif(MXE)

  add_executable(tandemng2015 ${CPP_FILES})
  target_compile_options(tandemng2015 PRIVATE -mwindows)
  set_target_properties(tandemng2015 PROPERTIES LINK_FLAGS "-Wl,--subsystem,windows ${CMAKE_EXE_LINKER_FLAGS}")

endif()


target_compile_definitions(tandemng2015 PUBLIC HEADER2015)

#-lpthread -L/usr/lib -lm -lexpat
target_link_libraries(tandemng2015
  Threads::Threads
  EXPAT::EXPAT
  Qt6::Core
  Qt6::Xml
  Qt6::Sql
  Qt6::Qml
  PappsoMSpp::Core
)




install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/tandemng2015 DESTINATION bin)

=== src/2015p/CMakeLists.txt ===
# CMake script to build tandemng (X!Tandem fork)
# Author: Olivier Langella
# Created: 24/02/2024


#configure_file(${CMAKE_SOURCE_DIR}/src/config.h.cmake ${CMAKE_SOURCE_DIR}/src/config.h)

# File list


file(GLOB CPP_FILES ${CMAKE_SOURCE_DIR}/src/msequence.cpp ${CMAKE_SOURCE_DIR}/src/masscalc.cpp ${CMAKE_SOURCE_DIR}/src/xmlparameter.cpp ${CMAKE_SOURCE_DIR}/src/msequtilities.cpp ${CMAKE_SOURCE_DIR}/src/mreport.cpp ${CMAKE_SOURCE_DIR}/src/lib/*.cpp ${CMAKE_SOURCE_DIR}/src/mzid_report.cpp ${CMAKE_SOURCE_DIR}/src/2015p/*.cpp)

#message("i2MassChroQ_SRCS:  ${i2MassChroQ_SRCS}")


if(UNIX AND NOT APPLE)

  add_executable(tandemng2015p ${CPP_FILES})

elseif(APPLE)

elseif(MXE)

  add_executable(tandemng2015p ${CPP_FILES})
  target_compile_options(tandemng2015p PRIVATE -mwindows)
  set_target_properties(tandemng2015p PROPERTIES LINK_FLAGS "-Wl,--subsystem,windows ${CMAKE_EXE_LINKER_FLAGS}")

endif()

target_compile_definitions(tandemng2015p PUBLIC HEADER2015P)

#-lpthread -L/usr/lib -lm -lexpat
target_link_libraries(tandemng2015p
  Threads::Threads
  EXPAT::EXPAT
  Qt6::Core
  Qt6::Xml
  Qt6::Sql
  Qt6::Qml
  PappsoMSpp::Core
)




install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/tandemng2015p DESTINATION bin)

=== debian/control ===
Source: tandemng
Section: science
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Standards-Version: 4.2.1
Build-Depends: debhelper (>= 9.20151219),
               libpappsomspp-core-dev (>= 0.11.2),
               libpappsomspp-gui-dev (>= 0.11.2),
               libboost1.88-dev,
               libboost-thread1.88-dev,
               libboost-filesystem1.88-dev,
               libboost-iostreams1.88-dev,
               libboost-chrono1.88-dev,
               libboost-container1.88-dev,
               libboost-random1.88-dev,
               libpwizlite-dev,
               liblzf-dev,
               libquazip1-qt6-dev,
               libodsstream-dev,
               libsqlite3-dev,
               cmake,
               qt6-base-dev,
               qt6-declarative-dev,
               libqt6svg6-dev, 
               libexpat1-dev
Homepage: http://www.thegpm.org/TANDEM/
Vcs-Browser: https://salsa.debian.org/debichem-team/tandem-mass.git
Vcs-Git: https://salsa.debian.org/debichem-team/tandem-mass.git

Package: tandemng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: tandemng-mass
Description: mass spectrometry software for protein identification
 X! Tandem can match tandem mass spectra with peptide sequences, in a
 process that is commonly used to perform protein identification.
 .
 This software has a very simple, unsophisticated application
 programming interface (API): it simply takes an XML file of
 instructions on its command line, and outputs the results into an XML
 file, which has been specified in the input XML file. The output file
 format is described at
 http://www.thegpm.org/docs/X_series_output_form.pdf.
 .
 Unlike some earlier generation search engines, all of the X! Series
 search engines calculate statistical confidence (expectation values)
 for all of the individual spectrum-to-sequence assignments. They also
 reassemble all of the peptide assignments in a data set onto the
 known protein sequences and assign the statistical confidence that
 this assembly and alignment is non-random. The formula for which can
 be found here. Therefore, separate assembly and statistical analysis
 software, e.g. PeptideProphet and ProteinProphet, do not need to be
 used.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DESTDIR=$(CURDIR)/debian/tmp

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Release -DCMAKE_SKIP_RPATH=1
	
override_dh_auto_install:
	dh_auto_install -- DESTDIR=$(DESTDIR)
